package vista;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.util.List;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;

import modelo.Carta;
import modelo.Jugador;

public class PanelJuego extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public JPanel norte;
	public PanelCartas cartas;
	public JPanel panel_1;
	public PanelJugador panel_2;
	public JPanel panel_3;
	public PanelJugador panel_4;
	public PanelCentral panel_5;
	public PanelJugador panel_6;
	public JPanel panel_7;
	public PanelJugador panel_8;
	public JPanel panel_9;
	public JLabel lblSentido;

	// public List<BotonCarta> listaCartas;

	public PanelJuego() {
		super();
		// listaCartas = new LinkedList<BotonCarta>();
		setSize(new Dimension(450, 450));
		setBackground(Color.BLACK);
		setSize(450, 550);

		norte = new JPanel();
		norte.setLocation(0, 0);
		norte.setBackground(new Color(0, 100, 0));
		norte.setLayout(new GridLayout(3, 3));
		norte.setSize(450, 450);

		panel_1 = new JPanel();
		panel_1.setBackground(new Color(0, 100, 0));
		norte.add(panel_1);

		panel_2 = new PanelJugador();
		panel_2.setBackground(new Color(0, 100, 0));
		norte.add(panel_2);

		panel_3 = new JPanel();
		panel_3.setBackground(new Color(0, 100, 0));
		norte.add(panel_3);

		panel_4 = new PanelJugador();
		panel_4.setBackground(new Color(0, 100, 0));
		norte.add(panel_4);

		panel_5 = new PanelCentral();
		panel_5.setBackground(new Color(0, 100, 0));
		norte.add(panel_5);

		panel_6 = new PanelJugador();
		panel_6.setBackground(new Color(0, 100, 0));
		norte.add(panel_6);

		panel_7 = new JPanel();
		panel_7.setBackground(new Color(0, 100, 0));
		norte.add(panel_7);

		panel_8 = new PanelJugador();
		panel_8.setBackground(new Color(0, 100, 0));
		norte.add(panel_8);

		panel_9 = new JPanel();
		panel_9.setBackground(new Color(0, 100, 0));
		norte.add(panel_9);
		panel_9.setLayout(new BorderLayout(0, 0));

		lblSentido = new JLabel("Sentido");
		lblSentido.setAlignmentX(Component.RIGHT_ALIGNMENT);
		lblSentido.setIcon(new ImageIcon(Vista.class
				.getResource("/resources/antihorario.jpg")));
		panel_9.add(lblSentido);

		cartas = new PanelCartas();
		cartas.setLocation(0, 450);

		setLayout(null);

		add(norte);
		add(cartas);

	}

	public void incializa(List<Jugador> jugadores) {
		panel_2.inicializa(jugadores.get(0));
		panel_4.inicializa(jugadores.get(1));
		panel_6.inicializa(jugadores.get(3));
		panel_8.inicializa(jugadores.get(2));
	}

	public void setJugador(int jugador) {
		panel_2.setJugador(false);
		panel_4.setJugador(false);
		panel_6.setJugador(false);
		panel_8.setJugador(false);
		switch (jugador) {
		case 0:
			panel_2.setJugador(true);
			break;
		case 1:
			panel_4.setJugador(true);
			break;
		case 2:
			panel_8.setJugador(true);
			break;
		case 3:
			panel_6.setJugador(true);
			break;

		}
	}

	public void setMesa(Carta c) {
		panel_5.lblMesa.setText(c.toString());
	}

//	public void setCartasHumano(Jugador j) {
//		// cartas.removeAll();
//		// listaCartas.clear();
//		Carta c;
//		for (int i = 0; i < j.size(); i++) {
//			c = j.getCarta(i);
//			BotonCarta bc = new BotonCarta(c);
//			bc.setEnabled(false);
//			bc.setActionCommand("botonCarta");
//			// listaCartas.add(bc);
//			cartas.add(bc);
//		}
//	}

	public void setSentido(int sentido) {
		if (sentido > 0)
			lblSentido.setIcon(new ImageIcon(Vista.class
					.getResource("/resources/antihorario.jpg")));
		else
			lblSentido.setIcon(new ImageIcon(Vista.class
					.getResource("/resources/horario.jpg")));

	}

	public void setNumCartas(List<Jugador> jugadores) {
		panel_2.setNumCartas(jugadores.get(0));
		panel_4.setNumCartas(jugadores.get(1));
		panel_8.setNumCartas(jugadores.get(2));
		panel_6.setNumCartas(jugadores.get(3));
	}

	public void activarCartasNormal(Carta top, Jugador humano) {

		BotonCarta bc;
		// Activo cartas para echar
		for (int i = 0; i < humano.size(); i++) {
			bc = (BotonCarta)cartas.getComponent(i);
			//bc = cartas.getCarta(i);
			// BotonCarta bc = vista.pnlJuego.cartas.getCarta(i);
			if (bc.getNumero() == top.getNumero()
					|| bc.getPalo() == top.getPalo() || bc.getNumero() == 11) {

				bc.setEnabled(true);
				bc.setActionCommand("botonCarta");
			}
		}
	}

}
